import 'package:bloc_stream/bloc_stream.dart';
import 'package:riverpod/riverpod.dart';

import 'bloc_stream_provider.dart';

class BlocStreamProviderBuilder {
  const BlocStreamProviderBuilder();

  BlocStreamProvider<Bloc, Value> call<Bloc extends BlocStream<Value>, Value>(
    Bloc Function(ProviderReference ref) create, {
    String? name,
  }) {
    return BlocStreamProvider(create, name: name);
  }

  AutoDisposeBlocStreamProviderBuilder get autoDispose {
    return const AutoDisposeBlocStreamProviderBuilder();
  }

  BlocStreamProviderFamilyBuilder get family {
    return const BlocStreamProviderFamilyBuilder();
  }
}

class BlocStreamProviderFamilyBuilder {
  const BlocStreamProviderFamilyBuilder();

  BlocStreamProviderFamily<Bloc, Value, Param>
      call<Bloc extends BlocStream<Value>, Value, Param>(
    Bloc Function(ProviderReference ref, Param param) create, {
    String? name,
  }) {
    return BlocStreamProviderFamily(create, name: name);
  }

  AutoDisposeBlocStreamProviderFamilyBuilder get autoDispose {
    return const AutoDisposeBlocStreamProviderFamilyBuilder();
  }
}

class AutoDisposeBlocStreamProviderBuilder {
  const AutoDisposeBlocStreamProviderBuilder();

  AutoDisposeBlocStreamProvider<Bloc, Value>
      call<Bloc extends BlocStream<Value>, Value>(
    Bloc Function(AutoDisposeProviderReference ref) create, {
    String? name,
  }) {
    return AutoDisposeBlocStreamProvider(create, name: name);
  }

  AutoDisposeBlocStreamProviderFamilyBuilder get family {
    return const AutoDisposeBlocStreamProviderFamilyBuilder();
  }
}

/// Builds a [AutoDisposeBlocStreamProviderFamily].
class AutoDisposeBlocStreamProviderFamilyBuilder {
  /// Builds a [AutoDisposeBlocStreamProviderFamily].
  const AutoDisposeBlocStreamProviderFamilyBuilder();

  AutoDisposeBlocStreamProviderFamily<Bloc, Value, Param>
      call<Bloc extends BlocStream<Value>, Value, Param>(
    Bloc Function(AutoDisposeProviderReference ref, Param param) create, {
    String? name,
  }) {
    return AutoDisposeBlocStreamProviderFamily(create, name: name);
  }
}
