import 'package:riverpod/riverpod.dart';

extension Legacy<T> on RootProvider<Object?, T> {
  void Function() watchOwner(
    ProviderContainer container,
    void Function(T value) listener,
  ) {
    final sub = container.listen<T>(
      this,
      mayHaveChanged: (sub) => listener(sub.read()),
    );
    listener(sub.read());
    return sub.close;
  }

  ProviderSubscription<T> addLazyListener(
    ProviderContainer container, {
    required void Function() mayHaveChanged,
    required void Function(T value) onChange,
  }) {
    final sub = container.listen<T>(
      this,
      mayHaveChanged: (sub) => mayHaveChanged(),
      didChange: (sub) => onChange(sub.read()),
    );
    onChange(sub.read());
    return sub;
  }
}
